/* Amavect! */
#include <u.h>
#include <libc.h>
#include <draw.h>
#include <event.h>

ulong getpixelcolor(void);
void redraw(void);
void eresized(int new);
void main();

Image* pixel; /* The selected pixel color */

/* Returns the color of the 1x1 pixel image */
ulong
getpixelcolor()
{
	uchar data[3];
	unloadimage(pixel, pixel->r, data, sizeof(data));
	return (data[2]<<16) + (data[1]<<8) + data[0];
}

/* Regenerate image */
void
redraw()
{
	draw(screen, screen->r, pixel, nil, ZP);
}

/* Reobtain window on resizing */
void
eresized(int)
{
	if(getwindow(display, Refnone) < 0)
		sysfatal("colorpick: %r");
	redraw();
}

void
main()
{
	int screenfd; /* File descriptor of /dev/screen */
	Image* screenimg; /* A snapshot of the screen */
	ulong c; /* The selected color, RGB form */
	char *buttons[] = { "Finish", "Cancel", 0 };
	Menu menu = { buttons };
	ulong evtype;
	Mouse m;
	Event e;
	
	if(initdraw(nil, nil, "colorpick") < 0)
		sysfatal("colorpick: %r");
	
	einit(Emouse | Ekeyboard);
	/* get screen image */
	screenfd = open("/dev/screen", OREAD);
	if(screenfd < 0)
		sysfatal("cannot read /dev/screen: %r");
	screenimg = readimage(display, screenfd, 0);
	/* init chosen pixel */
	Rectangle r = {{0,0},{1,1}};
	pixel = allocimage(display, r, RGB24, 1, DOpaque);
	eresized(0);
	/* event loop */
	for(;;){
		evtype = event(&e);
		
		if(evtype == Emouse){
			m = e.mouse;
			if(m.buttons == 1){
				/* Get the pixel on screenimg at m.xy, convert to RGB24 */
				draw(pixel, pixel->r, screenimg, nil, m.xy);
				redraw();
			}
			if(m.buttons & 4){
				switch(emenuhit(3, &m, &menu)){
					case 0 :
						/* close display before printing */
						c = getpixelcolor();
						closedisplay(display); 
						print("0x%06ulXFF\n", c);
						exits(0);
						break;
					case 1 :
						closedisplay(display);
						exits(0);
						break;
					default:
						break;
				}
			}
		}
	}
}
